signature REGISTRY = sig

(* A "registry" is a collection of named functions with a common
   domain type.  Operations are provided for "poking" only those
   functions whose keys are equal to a given string by sending them
   a given argument, or for poking all registered functions. *)

type 'a registry

val new: 'a registry
val register: ('a registry) -> string -> ('a->unit) -> 'a registry
val poke_one: ('a registry) -> string -> 'a -> unit
val poke_all: ('a registry) -> 'a -> unit

end
