signature TYP = sig

structure Globals: GLOBALS
include GLOBALS

type T
val tvar: int -> T
val arrow: T -> T -> T
val all: Id.T -> T -> T -> T
val some: Id.T -> T -> T -> T
val meet: (T list) -> T
val obj: Id.T -> T -> T
val minus: T -> (Id.T list) -> T
val NS: T

datatype Exploded = 
	    EXPTVAR of int
	  | EXPARROW of T * T
	  | EXPALL of Id.T * T * T
	  | EXPSOME of Id.T * T * T
	  | EXPMEET of T list
	  | EXPOBJ of Id.T * T 
	  | EXPMINUS of T * (Id.T list)

val explode: T -> Exploded

val eq: T -> T -> bool

val relocate: int -> T -> T

val tsubst_top: 
	(* substitute... *)			T 
	(* for instances of #0 in... *)	     -> T 
			     		     -> T
val occurs_free_in:
	(* is var #... *)		int
	(* free in type... ? *)      -> T
				     -> bool
val prt_exactly: T -> unit

end

