signature TYPHELPER = sig

structure Typ: TYP
structure TEnv: TENV
structure Globals: GLOBALS
sharing Typ.Globals = Globals
    and TEnv.Typ = Typ
include GLOBALS

datatype pretyp = 
	    PRETVAR of Id.T
	  | PREARROW of pretyp * pretyp
	  | PREALL of Id.T * pretyp * pretyp
	  | PRESOME of Id.T * pretyp * pretyp
	  | PREMEET of pretyp list
	  | PREOBJ of Id.T * pretyp
	  | PREMINUS of pretyp * (Id.T list)

val debruijnify: TEnv.T -> pretyp -> Typ.T

val prt: TEnv.T -> Typ.T -> unit
val prt_outer: TEnv.T -> Typ.T -> unit
val prt_nested: TEnv.T -> Typ.T -> unit

val prt_tenv: TEnv.T -> unit

end




