% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%   Polymorphic  Extensible Objects    %%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

PolyExtensibleMethods ==
  Fun(SelfM:*->*->*)
  Fun(E:*)
  Fun(SelfR:*)
    All(FinalR)
    SelfM(E)(FinalR) ->
    (Extractor FinalR SelfR) ->
    SelfM(E)(FinalR);

MonoExtensibleObject ==
  Fun(SelfM:*->*->*) 
  Fun(E:*)
    Some(SelfR)
      {localstate: SelfR,
       buildM: PolyExtensibleMethods SelfM E SelfR};
     
PolyExtensibleObject ==
  Fun(SelfM:*->*->*) 
    All(E)
      MonoExtensibleObject SelfM E;
     
polyNew =
  fun(SelfM < Top3) 
  fun(E < Top1)
  fun(self: PolyExtensibleObject SelfM)
    open self[E] as [SelfR,selfData] in
      pack 
      {
        state = selfData.localstate,
        methods = 
          rec [SelfM(E)(SelfR)]
            (fun(mr:SelfM(E)(SelfR))
              selfData.buildM [SelfR] mr (idExtractor [SelfR]))
      } 
      as Object(SelfM(E)) hiding SelfR end 
    end;

polyExtend = 
  fun(SelfM < Top3)
  fun(SubM < SelfM)            
  fun(SubDeltaR < Top2)
  fun(self: PolyExtensibleObject SelfM)
  fun(deltastate: All(E) SubDeltaR(E))
  fun(build: All(FinalR)
             All(E)
             SelfM(E)(FinalR) -> 
             SubM(E)(FinalR) -> 
             (Extractor FinalR (SubDeltaR(E))) -> 
             SubM(E)(FinalR))
    fun(E < Top1)
    open self[E] as [SelfR,selfData] in 
      pack {
       localstate = pair [SelfR] [SubDeltaR(E)] 
                         (selfData.localstate) (deltastate[E]),
       buildM = 
         fun(FinalR)
         fun(mr: SubM(E)(FinalR))
         fun(e: Extractor FinalR (Pair SelfR (SubDeltaR(E))))
           build [FinalR] [E]
             (selfData.buildM [FinalR] mr
                (composeExtractors [FinalR] [Pair SelfR (SubDeltaR(E))] [SelfR]
                                   e (fstExtractor [SelfR] [SubDeltaR(E)])))
             mr
             (composeExtractors 
                [FinalR] [Pair SelfR (SubDeltaR(E))] [SubDeltaR(E)]
                e (sndExtractor [SelfR] [SubDeltaR(E)]))
       } as MonoExtensibleObject SubM E
       hiding Pair SelfR (SubDeltaR(E))
       end end;



PolyThingM == Fun(E:*) Fun(T:*) {};

extensiblePolyThing =
  fun(E)
    pack {
     localstate = unit,
     buildM = fun(FinalR)
              fun(mr: PolyThingM(E)(FinalR))
              fun(e: Extractor FinalR Unit)
                 {}
    } as MonoExtensibleObject PolyThingM E
    hiding Unit end;

myIntThing = polyNew [PolyThingM] [Int] extensiblePolyThing;


CollectionM == 
  Fun(E:*)
  Fun(X:*) 
    {do: X -> (E->Unit) -> Unit,
     fold: X -> All(A) (E->A->A) -> A -> A};
     
extensibleCollection = 
  polyExtend [PolyThingM] [CollectionM] [Fun(E:*) Unit] extensiblePolyThing
    (fun(E) unit)
    (fun(FinalR)
     fun(E)
     fun(m: PolyThingM(E)(FinalR))
     fun(mr: CollectionM(E)(FinalR))
     fun(e: Extractor FinalR Unit)
       {do = mr.do,
        fold = fun(r:FinalR) 
               fun(A) 
               fun(f:E->A->A)
               fun(i:A)
                 let acc = ref [A] i in
                   let dummy = 
                     mr.do r 
                       (fun(x:E) 
                         store [A] acc (f x (read [A] acc))) 
                 in read [A] acc 
                 end end
       });

send_fold =
  fun(M < CollectionM)
  fun(E < Top1)
  fun(c : Object(M(E)))
  fun(A < Top1)
  fun(f : E -> A -> A)
  fun(s : A)
    open c as [R,r] in
      r.methods.fold r.state [A] f s
    end;


SetM == 
  Fun(E:*)
  Fun(X:*) 
    {do: X -> (E->Unit) -> Unit,
     fold: X -> All(A) (E->A->A) -> A -> A,
     add: X -> E -> X};
     
extensibleSet = 
  polyExtend [CollectionM] [SetM] [Fun(E:*) List(E)] extensibleCollection
    (fun(E) nil[E])
    (fun(FinalR)
     fun(E)
     fun(m: CollectionM(E)(FinalR))
     fun(mr: CollectionM(E)(FinalR))
     fun(e: Extractor FinalR (List(E)))
       {do   = fun(r: FinalR) 
               fun(f: E->Unit)
                 (rec [List(E) -> Unit]
                   (fun(g:List(E)->Unit)
                    fun(l:List(E))
                     if [Unit] (empty[E] l)
                       unit
                       (let dummy = f (car[E] l)
                        in g (cdr[E] l)
                        end)))
                 (e r).view,
        fold = m.fold,
        add  = fun(r:FinalR) 
               fun(i:E)
                 (e r).update (fun(l:List(E)) cons[E] i l)
       });

send_add =
  fun(M < SetM)
  fun(E < Top1)
  fun(c : Object(M(E)))
  fun(e : E)
    open c as [R,r] in
      pack {
        state = r.methods.add r.state e,
        methods = r.methods}
      as Object(M(E)) hiding R
    end end;

myIntSet = polyNew [SetM] [Int] extensibleSet;

s1 = send_add [SetM] [Int] myIntSet 0;

i = send_fold [SetM] [Int] myIntSet [Int] plus 0;

