signature EVAL = sig

structure Globals: GLOBALS
structure Typ: TYP
structure TEnv: TENV
structure TypHelper: TYPHELPER
structure Trm: TRM
sharing Typ.Globals = Globals
    and TypHelper.Typ = Typ
    and TypHelper.TEnv = TEnv
    and Trm.TEnv = TEnv
    and Trm.Typ.Globals = Globals
    and Trm.Id = Globals.Id

include GLOBALS

type env
type code

val empty_env : env
val push_env_binding : env -> Id.T -> code -> env
val push_env_const : env -> Id.T -> env
val push_env_null : env -> Id.T -> env

exception Eval of unit->unit
val eval : TEnv.T -> env -> Id.T -> Trm.T -> code

val dummycode : code

type printercontext
val empty_printercontext: printercontext
val define_printer: printercontext -> Typ.T -> code -> printercontext
val deepen_printers: printercontext -> printercontext
val deepen_printers_by: printercontext -> int -> printercontext
val eval_print: TEnv.T -> printercontext -> Typ.T -> Id.T -> unit

end
